//*****************************************************************************
// REPAUTO.H
//
// This module contains the .odl generated interface definitions for the
// Repository engine.  The compiled type library can be found using the
// PROGID "Microsoft Repository".
//
// Copyright (c) 1995-1996 by Microsoft Corporation, All Rights Reserved
//*****************************************************************************
/* This header file machine-generated by mktyplib.exe */
/* Interface to type library: RepositoryTypeLib */

#ifndef _RepositoryTypeLib_H_
#define _RepositoryTypeLib_H_

DEFINE_GUID(LIBID_RepositoryTypeLib,0x2DF7E2FBL,0x60D2,0x11CF,0x92,0x0E,0x00,0xAA,0x00,0xA1,0xEB,0x95);
#ifndef BEGIN_INTERFACE
#define BEGIN_INTERFACE
#endif

typedef enum _ConnectionFlags {
    REPOS_CONN_EXCLUSIVE = 1,
    REPOS_CONN_NEWCACHE = 2
} ConnectionFlags;

typedef enum _TransactionFlags {
    TXN_RESET_OPTIONS = 1,
    TXN_NORMAL = 2,
    TXN_EXCLUSIVE_WRITEBACK = 3,
    TXN_EXCLUSIVE_WRITETHROUGH = 4,
    TXN_TIMEOUT_DURATION = 5,
    TXN_START_TIMEOUT = 6,
    TXN_QUERY_TIMEOUT = 7,
    TXN_DBMS_READONLY = 8
} TransactionFlags;

typedef enum _TransactionValues {
    TXN_EXCL_NO = 0,
    TXN_EXCL_YES = 1
} TransactionValues;

typedef enum _InterfaceDefFlags {
    INTERFACE_EXTENSIBLE = 1,
    INTERFACE_HIDDEN = 2
} InterfaceDefFlags;

typedef enum _InterfaceMemberFlags {
    INTERFACEMEMBER_HIDDEN = 1
} InterfaceMemberFlags;

typedef enum _PropertyDefFlags {
    PROPERTY_INVERTED = 1
} PropertyDefFlags;

typedef enum _CollectionDefFlags {
    COLLECTION_NAMING = 1,
    COLLECTION_UNIQUENAMING = 2,
    COLLECTION_CASESENSITIVE = 4,
    COLLECTION_SEQUENCED = 8,
    COLLECTION_PROPAGATEDELETE = 16
} CollectionDefFlags;

interface IRepository;

interface IRepositoryDispatch;

interface IReposProperties;

DEFINE_GUID(IID_IRepositoryDispatch,0x6E2270F6L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRepositoryDispatch */
#undef INTERFACE
#define INTERFACE IRepositoryDispatch

DECLARE_INTERFACE_(IRepositoryDispatch, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
};

DEFINE_GUID(IID_IRepositoryItem,0x6E2270F0L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRepositoryItem */
#undef INTERFACE
#define INTERFACE IRepositoryItem

DECLARE_INTERFACE_(IRepositoryItem, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IRepositoryItem methods */
    STDMETHOD(get_Type)(THIS_ VARIANT FAR* psTypeID) PURE;
    STDMETHOD(get_Repository)(THIS_ IRepository FAR* FAR* ppIRepository) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(put_Name)(THIS_ BSTR Name) PURE;
    STDMETHOD(get_Interface)(THIS_ VARIANT Iface, IDispatch * FAR* ppIIface) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Lock)(THIS) PURE;
};

DEFINE_GUID(IID_IRepositoryObject,0x6E2270F2L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRepositoryObject */
#undef INTERFACE
#define INTERFACE IRepositoryObject

DECLARE_INTERFACE_(IRepositoryObject, IRepositoryItem)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;

    /* IRepositoryItem methods */
    STDMETHOD(get_Type)(THIS_ VARIANT FAR* psTypeID) PURE;
    STDMETHOD(get_Repository)(THIS_ IRepository FAR* FAR* ppIRepository) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(put_Name)(THIS_ BSTR Name) PURE;
    STDMETHOD(get_Interface)(THIS_ VARIANT Iface, IDispatch * FAR* ppIIface) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Lock)(THIS) PURE;
#endif

    /* IRepositoryObject methods */
    STDMETHOD(get_ObjectID)(THIS_ VARIANT FAR* psObjID) PURE;
    STDMETHOD(get_InternalID)(THIS_ VARIANT FAR* psIntID) PURE;
    STDMETHOD(Refresh)(THIS_ long iMilliseconds) PURE;
};

DEFINE_GUID(IID_IRepositoryObjectStorage,0x6E22711DL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRepositoryObjectStorage */
#undef INTERFACE
#define INTERFACE IRepositoryObjectStorage

DECLARE_INTERFACE_(IRepositoryObjectStorage, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IRepositoryObjectStorage methods */
    STDMETHOD(InitNew)(THIS_ IRepository FAR* pIRepos, long lCookie) PURE;
    STDMETHOD(Load)(THIS_ IRepository FAR* pIRepos, long lCookie) PURE;
    STDMETHOD(get_PropertyInterface)(THIS_ VARIANT sIface, IRepositoryDispatch FAR* FAR* ppIIface) PURE;
};

DEFINE_GUID(IID_IRelationship,0x6E2270F3L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRelationship */
#undef INTERFACE
#define INTERFACE IRelationship

DECLARE_INTERFACE_(IRelationship, IRepositoryItem)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;

    /* IRepositoryItem methods */
    STDMETHOD(get_Type)(THIS_ VARIANT FAR* psTypeID) PURE;
    STDMETHOD(get_Repository)(THIS_ IRepository FAR* FAR* ppIRepository) PURE;
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(put_Name)(THIS_ BSTR Name) PURE;
    STDMETHOD(get_Interface)(THIS_ VARIANT Iface, IDispatch * FAR* ppIIface) PURE;
    STDMETHOD(Delete)(THIS) PURE;
    STDMETHOD(Lock)(THIS) PURE;
#endif

    /* IRelationship methods */
    STDMETHOD(get_Source)(THIS_ IRepositoryObject FAR* FAR* ppIReposObj) PURE;
    STDMETHOD(get_Target)(THIS_ IRepositoryObject FAR* FAR* ppIReposObj) PURE;
    STDMETHOD(get_Origin)(THIS_ IRepositoryObject FAR* FAR* ppIReposObj) PURE;
    STDMETHOD(get_Destination)(THIS_ IRepositoryObject FAR* FAR* ppIReposObj) PURE;
};

DEFINE_GUID(IID_IReposProperty,0x6E2270F4L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IReposProperty */
#undef INTERFACE
#define INTERFACE IReposProperty

DECLARE_INTERFACE_(IReposProperty, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IReposProperty methods */
    STDMETHOD(get_Name)(THIS_ BSTR FAR* pName) PURE;
    STDMETHOD(get_Type)(THIS_ VARIANT FAR* psTypeID) PURE;
    STDMETHOD(get_Value)(THIS_ VARIANT FAR* psValue) PURE;
    STDMETHOD(put_Value)(THIS_ VARIANT sValue) PURE;
};

DEFINE_GUID(IID_IReposProperties,0x6E2270F5L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IReposProperties */
#undef INTERFACE
#define INTERFACE IReposProperties

DECLARE_INTERFACE_(IReposProperties, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IReposProperties methods */
    STDMETHOD(get_Count)(THIS_ long FAR* piCount) PURE;
    STDMETHOD(get_Item)(THIS_ VARIANT sItem, IReposProperty FAR* FAR* ppIProp) PURE;
    STDMETHOD(_NewEnum)(THIS_ IUnknown * FAR* ppIEnum) PURE;
    STDMETHOD(get_Type)(THIS_ VARIANT FAR* psTypeID) PURE;
};

DEFINE_GUID(IID_IRelationshipCol,0x6E2270F7L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRelationshipCol */
#undef INTERFACE
#define INTERFACE IRelationshipCol

DECLARE_INTERFACE_(IRelationshipCol, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IRelationshipCol methods */
    STDMETHOD(get_Count)(THIS_ long FAR* piCount) PURE;
    STDMETHOD(get_Item)(THIS_ VARIANT sItem, IRelationship FAR* FAR* ppIItem) PURE;
    STDMETHOD(_NewEnum)(THIS_ IUnknown * FAR* ppIEnum) PURE;
    STDMETHOD(Add)(THIS_ IDispatch * pIReposObj, BSTR Name, IRelationship FAR* FAR* ppIRelship) PURE;
    STDMETHOD(Remove)(THIS_ VARIANT sItem) PURE;
    STDMETHOD(get_Type)(THIS_ VARIANT FAR* psTypeID) PURE;
    STDMETHOD(Insert)(THIS_ IDispatch * pIReposObj, long iIndex, BSTR Name, IRelationship FAR* FAR* ppIRelship) PURE;
    STDMETHOD(Move)(THIS_ long iIndexFrom, long iIndexTo) PURE;
    STDMETHOD(Refresh)(THIS_ long iMilliseconds) PURE;
    STDMETHOD(get_Source)(THIS_ IRepositoryObject FAR* FAR* ppIObj) PURE;
};

DEFINE_GUID(IID_IObjectCol,0x6E2270F8L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IObjectCol */
#undef INTERFACE
#define INTERFACE IObjectCol

DECLARE_INTERFACE_(IObjectCol, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IObjectCol methods */
    STDMETHOD(get_Count)(THIS_ long FAR* piCount) PURE;
    STDMETHOD(get_Item)(THIS_ VARIANT sItem, IRepositoryObject FAR* FAR* ppIItem) PURE;
    STDMETHOD(_NewEnum)(THIS_ IUnknown * FAR* ppIEnum) PURE;
    STDMETHOD(Refresh)(THIS_ long iMilliseconds) PURE;
};

DEFINE_GUID(IID_ITargetObjectCol,0x6E227115L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: ITargetObjectCol */
#undef INTERFACE
#define INTERFACE ITargetObjectCol

DECLARE_INTERFACE_(ITargetObjectCol, IObjectCol)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IObjectCol methods */
    STDMETHOD(get_Count)(THIS_ long FAR* piCount) PURE;
    STDMETHOD(get_Item)(THIS_ VARIANT sItem, IRepositoryObject FAR* FAR* ppIItem) PURE;
    STDMETHOD(_NewEnum)(THIS_ IUnknown * FAR* ppIEnum) PURE;
    STDMETHOD(Refresh)(THIS_ long iMilliseconds) PURE;
#endif

    /* ITargetObjectCol methods */
    STDMETHOD(Add)(THIS_ IDispatch * pIReposObj, BSTR Name, IRelationship FAR* FAR* ppIRelship) PURE;
    STDMETHOD(Remove)(THIS_ VARIANT sItem) PURE;
    STDMETHOD(get_Type)(THIS_ VARIANT FAR* psTypeID) PURE;
    STDMETHOD(Insert)(THIS_ IDispatch * pIReposObj, long iIndex, BSTR Name, IRelationship FAR* FAR* ppIRelship) PURE;
    STDMETHOD(Move)(THIS_ long iIndexFrom, long iIndexTo) PURE;
    STDMETHOD(get_Source)(THIS_ IRepositoryObject FAR* FAR* ppIObj) PURE;
};

DEFINE_GUID(IID_IRepositoryTransaction,0x6E2270F9L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRepositoryTransaction */
#undef INTERFACE
#define INTERFACE IRepositoryTransaction

DECLARE_INTERFACE_(IRepositoryTransaction, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IRepositoryTransaction methods */
    STDMETHOD(Begin)(THIS) PURE;
    STDMETHOD(Commit)(THIS) PURE;
    STDMETHOD(Abort)(THIS) PURE;
    STDMETHOD(get_Status)(THIS_ long FAR* piStatus) PURE;
    STDMETHOD(GetOption)(THIS_ long iOption, VARIANT FAR* psValue) PURE;
    STDMETHOD(SetOption)(THIS_ long iOption, VARIANT sValue) PURE;
    STDMETHOD(Flush)(THIS) PURE;
};

DEFINE_GUID(IID_IRepository,0x6E2270FAL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRepository */
#undef INTERFACE
#define INTERFACE IRepository

DECLARE_INTERFACE_(IRepository, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IRepository methods */
    STDMETHOD(Create)(THIS_ BSTR Connect, BSTR User, BSTR Password, long fFlags, IRepositoryObject FAR* FAR* ppIRoot) PURE;
    STDMETHOD(Open)(THIS_ BSTR Connect, BSTR User, BSTR Password, long fFlags, IRepositoryObject FAR* FAR* ppIRoot) PURE;
    STDMETHOD(CreateObject)(THIS_ VARIANT sTypeID, VARIANT sObjID, IRepositoryObject FAR* FAR* ppIReposObj) PURE;
    STDMETHOD(get_RootObject)(THIS_ IRepositoryObject FAR* FAR* ppIRoot) PURE;
    STDMETHOD(get_Object)(THIS_ VARIANT sObjID, IRepositoryObject FAR* FAR* ppIReposObj) PURE;
    STDMETHOD(Refresh)(THIS_ long iMilliseconds) PURE;
    STDMETHOD(ObjectIDToInternalID)(THIS_ VARIANT sObjID, VARIANT FAR* psIntID) PURE;
    STDMETHOD(InternalIDToObjectID)(THIS_ VARIANT sIntID, VARIANT FAR* psObjID) PURE;
    STDMETHOD(get_Transaction)(THIS_ IRepositoryTransaction FAR* FAR* ppITxn) PURE;
};

DEFINE_GUID(IID_IRepositoryODBC,0x6E227118L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IRepositoryODBC */
#undef INTERFACE
#define INTERFACE IRepositoryODBC

DECLARE_INTERFACE_(IRepositoryODBC, IDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;
#endif

    /* IRepositoryODBC methods */
    STDMETHOD(get_ReposConnection)(THIS_ long FAR* pHdbc) PURE;
    STDMETHOD(GetNewConnection)(THIS_ long FAR* pHdbc) PURE;
    STDMETHOD(FreeConnection)(THIS_ long Hdbc) PURE;
    STDMETHOD(get_ConnectionString)(THIS_ BSTR FAR* pConn) PURE;
    STDMETHOD(ExecuteQuery)(THIS_ BSTR Query, IDispatch * FAR* ppICol) PURE;
};

DEFINE_GUID(IID_IAnnotationalProps,0x6E227114L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IAnnotationalProps */
#undef INTERFACE
#define INTERFACE IAnnotationalProps

DECLARE_INTERFACE_(IAnnotationalProps, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IAnnotationalProps methods */
};

DEFINE_GUID(IID_ISummaryInformation,0x6E2270F1L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: ISummaryInformation */
#undef INTERFACE
#define INTERFACE ISummaryInformation

DECLARE_INTERFACE_(ISummaryInformation, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* ISummaryInformation methods */
};

DEFINE_GUID(IID_INamedObject,0x6E22711CL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: INamedObject */
#undef INTERFACE
#define INTERFACE INamedObject

DECLARE_INTERFACE_(INamedObject, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* INamedObject methods */
};

DEFINE_GUID(CLSID_RepositoryObject,0x6E2270FBL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class RepositoryObject;
#endif

DEFINE_GUID(CLSID_Relationship,0x6E2270FCL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class Relationship;
#endif

DEFINE_GUID(CLSID_ReposProperty,0x6E2270FDL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class ReposProperty;
#endif

DEFINE_GUID(CLSID_ReposProperties,0x6E2270FEL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class ReposProperties;
#endif

DEFINE_GUID(CLSID_RelationshipCol,0x6E2270FFL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class RelationshipCol;
#endif

DEFINE_GUID(CLSID_ObjectCol,0x6E227100L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class ObjectCol;
#endif

DEFINE_GUID(CLSID_Repository,0x6E227101L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class Repository;
#endif

interface IReposTypeInfo;

interface IInterfaceDef;

interface IInterfaceMember;

interface IClassDef;

interface ICollectionDef;

interface IPropertyDef;

DEFINE_GUID(IID_IClassDef,0x6E227102L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IClassDef */
#undef INTERFACE
#define INTERFACE IClassDef

DECLARE_INTERFACE_(IClassDef, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IClassDef methods */
    STDMETHOD(AddInterface)(THIS_ IInterfaceDef FAR* pIInterfaceDef, BSTR Flags) PURE;
    STDMETHOD(CreateInterfaceDef)(THIS_ VARIANT sObjID, BSTR Name, VARIANT sIID, IInterfaceDef FAR* pIAncestor, BSTR Flags, IInterfaceDef FAR* FAR* ppIIfaceDef) PURE;
    STDMETHOD(ObjectInstances)(THIS_ IObjectCol FAR* FAR* ppIObjectCol) PURE;
};

DEFINE_GUID(IID_IInterfaceDef,0x6E227103L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IInterfaceDef */
#undef INTERFACE
#define INTERFACE IInterfaceDef

DECLARE_INTERFACE_(IInterfaceDef, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IInterfaceDef methods */
    STDMETHOD(CreateRelationshipColDef)(THIS_ VARIANT sObjID, BSTR Name, long iDispID, VARIANT_BOOL IsOrigin, short fFlags, IReposTypeInfo FAR* pIRelshipDef, ICollectionDef FAR* FAR* ppIColDef) PURE;
    STDMETHOD(CreatePropertyDef)(THIS_ VARIANT sObjID, BSTR Name, long iDispID, short CType, IPropertyDef FAR* FAR* ppIPropDef) PURE;
    STDMETHOD(CreateMethodDef)(THIS_ VARIANT sObjID, BSTR Name, long iDispID, IInterfaceMember FAR* FAR* ppIMethodDef) PURE;
    STDMETHOD(ObjectInstances)(THIS_ IObjectCol FAR* FAR* ppIObjectCol) PURE;
};

DEFINE_GUID(IID_IInterfaceMember,0x6E227116L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IInterfaceMember */
#undef INTERFACE
#define INTERFACE IInterfaceMember

DECLARE_INTERFACE_(IInterfaceMember, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IInterfaceMember methods */
};

DEFINE_GUID(IID_ICollectionDef,0x6E227106L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: ICollectionDef */
#undef INTERFACE
#define INTERFACE ICollectionDef

DECLARE_INTERFACE_(ICollectionDef, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* ICollectionDef methods */
};

DEFINE_GUID(IID_IPropertyDef,0x6E227107L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IPropertyDef */
#undef INTERFACE
#define INTERFACE IPropertyDef

DECLARE_INTERFACE_(IPropertyDef, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IPropertyDef methods */
};

DEFINE_GUID(IID_IReposTypeLib,0x6E227104L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IReposTypeLib */
#undef INTERFACE
#define INTERFACE IReposTypeLib

DECLARE_INTERFACE_(IReposTypeLib, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IReposTypeLib methods */
    STDMETHOD(CreateClassDef)(THIS_ VARIANT sObjID, BSTR Name, VARIANT sClsID, IClassDef FAR* FAR* ppIClassDef) PURE;
    STDMETHOD(CreateInterfaceDef)(THIS_ VARIANT sObjID, BSTR Name, VARIANT sIID, IInterfaceDef FAR* pIAncestor, IInterfaceDef FAR* FAR* ppIIfaceDef) PURE;
    STDMETHOD(CreateRelationshipDef)(THIS_ VARIANT ObjID, BSTR Name, IReposTypeInfo FAR* FAR* ppIRelshipDef) PURE;
};

DEFINE_GUID(IID_IReposTypeInfo,0x6E227119L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IReposTypeInfo */
#undef INTERFACE
#define INTERFACE IReposTypeInfo

DECLARE_INTERFACE_(IReposTypeInfo, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IReposTypeInfo methods */
};

DEFINE_GUID(IID_IManageReposTypeLib,0x6E227105L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IManageReposTypeLib */
#undef INTERFACE
#define INTERFACE IManageReposTypeLib

DECLARE_INTERFACE_(IManageReposTypeLib, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IManageReposTypeLib methods */
    STDMETHOD(CreateTypeLib)(THIS_ VARIANT sObjID, BSTR Name, VARIANT TypeLibID, IReposTypeLib FAR* FAR* ppITypeLib) PURE;
};

DEFINE_GUID(IID_IReposRoot,0x6E227117L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

/* Definition of interface: IReposRoot */
#undef INTERFACE
#define INTERFACE IReposRoot

DECLARE_INTERFACE_(IReposRoot, IRepositoryDispatch)
{
BEGIN_INTERFACE
#ifndef NO_BASEINTERFACE_FUNCS

    /* IUnknown methods */
    STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
    STDMETHOD_(ULONG, AddRef)(THIS) PURE;
    STDMETHOD_(ULONG, Release)(THIS) PURE;

    /* IDispatch methods */
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT FAR* pctinfo) PURE;

    STDMETHOD(GetTypeInfo)(
      THIS_
      UINT itinfo,
      LCID lcid,
      ITypeInfo FAR* FAR* pptinfo) PURE;

    STDMETHOD(GetIDsOfNames)(
      THIS_
      REFIID riid,
      OLECHAR FAR* FAR* rgszNames,
      UINT cNames,
      LCID lcid,
      DISPID FAR* rgdispid) PURE;

    STDMETHOD(Invoke)(
      THIS_
      DISPID dispidMember,
      REFIID riid,
      LCID lcid,
      WORD wFlags,
      DISPPARAMS FAR* pdispparams,
      VARIANT FAR* pvarResult,
      EXCEPINFO FAR* pexcepinfo,
      UINT FAR* puArgErr) PURE;

    /* IRepositoryDispatch methods */
    STDMETHOD(get_Properties)(THIS_ IReposProperties FAR* FAR* ppIProps) PURE;
#endif

    /* IReposRoot methods */
};

DEFINE_GUID(CLSID_ClassDef,0x6E227108L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class ClassDef;
#endif

DEFINE_GUID(CLSID_InterfaceDef,0x6E227109L,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class InterfaceDef;
#endif

DEFINE_GUID(CLSID_CollectionDef,0x6E22710AL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class CollectionDef;
#endif

DEFINE_GUID(CLSID_MethodDef,0x6E22710BL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class MethodDef;
#endif

DEFINE_GUID(CLSID_PropertyDef,0x6E22710CL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class PropertyDef;
#endif

DEFINE_GUID(CLSID_RelationshipDef,0x6E22710DL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class RelationshipDef;
#endif

DEFINE_GUID(CLSID_ReposTypeLib,0x6E22710EL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class ReposTypeLib;
#endif

DEFINE_GUID(CLSID_ReposRoot,0x6E22710FL,0xF799,0x11CF,0x92,0x27,0x00,0xAA,0x00,0xA1,0xEB,0x95);

#ifdef __cplusplus
class ReposRoot;
#endif

#endif
